# 精度比对工具
msprobe精度比对工具主要通过对同一个模型，在两个不同的MindSpore环境下，输入相同的训练数据，在分别得到dump数据后，对这两个dump数据进行全量自动对比，从而快速定位不同版本之间的精度问题。

执行精度比对操作需要安装msprobe工具。详见《[MindStudio精度调试工具](../../README.md)》的“工具安装”章节。

## 命令行方式比对

精度比对工具目前使用方式为命令行形式，对MindSpore的dump数据仅支持单卡。

请先参见《[精度数据采集](./dump.md)》完成不同环境下MindSpore精度数据的采集。

### 操作步骤

1. 使用MindSpore进行dump，得到不同框架版本的dump数据。

2. 创建比对文件，文件内容及示例请参见“**比对文件**”。

3. 执行如下示例命令进行比对：

   ```shell
   msprobe -f mindspore compare -i ./compare.json -o ./output -s
   ```

   **完整参数说明**

   | 参数名               | 说明                                                                                                                                                                                                 | 是否必选 |
   |-------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------| -------- |
   | -i或--input_path   | 指定比对文件路径。比对文件内容及示例请参见“**比对文件**”。                                                                                                                                                                   | 是       |
   | -o或--output_path  | 配置比对结果文件存盘目录。文件名称基于时间戳自动生成，格式为：`compare_result_{timestamp}.xlsx`。                                                                                                                                  | 是       |
   | -s或--stack_mode   | 配置stack_mode的开关。仅当**比对文件**配置"stack_path"需要开启。通过直接配置该参数开启，默认未配置，表示关闭。                                                                                                                               | 否       |
   | -c或--compare_only | 仅比对开关。未配置默认关闭仅比对，使用自动精度分析，工具自动针对比对结果进行分析，识别到第一个精度不达标节点（在比对结果文件中的“Accuracy Reached or Not”列显示为No），并给出问题可能产生的原因（打屏展示并生成advisor_{timestamp}.txt文件）。该参数默认未配置，使用自动精度分析，通过配置该参数开启仅比对，关闭自动精度分析，仅输出比对结果表格。 | 否       |
   | -f或--fuzzy_match  | 模糊匹配。开启后，对于网络中同一层级且命名仅调用次数不同的API，可匹配并进行比对。通过直接配置该参数开启，默认未配置，表示关闭。                                                                                                                                  | 否       |

4. 查看比对结果，请详见PyTorch目录下的《[精度比对工具](../../pytorch/doc/ptdbg_ascend_compare.md)》的“比对结果分析”章节。

### 比对文件

以在当前目录创建./compare.json为例，单卡场景示例如下：


  ```json
  {
  "npu_path": "./npu_dump/dump.json",
  "bench_path": "./bench_dump/dump.json",
  "stack_path": "./npu_dump/stack.json",
  "is_print_compare_log": true
  }
  ```


**参数说明**

| 参数名               | 说明                                                         | 是否必选           |
| -------------------- | ------------------------------------------------------------ | ------------------ |
| npu_path             | 配置NPU环境下的dump.json文件（单卡场景）。数据类型：str。 | 是                 |
| bench_path           | 配置CPU、GPU或NPU环境下的dump.json文件（单卡场景）。数据类型：str。 | 是                 |
| stack_path           | 配置NPU dump目录下的stack.json文件。数据类型：str。          | 是|
| is_print_compare_log | 配置是否开启日志打屏。可取值True或False，默认为True。数据类型：bool      | 否                 |